
uniform lowp    sampler2D texture0;
uniform lowp   vec4 threshold;
uniform lowp   vec4 origFactor;
uniform lowp   vec4 bloomFactor;
varying mediump vec2 vCoord0;
varying mediump vec2 vCoord1;
varying mediump vec2 vCoord2;
varying mediump vec2 vCoord3;
varying mediump vec2 vCoord4;
void main()
{
	lowp vec4 bloom = 0.25 * texture2D(texture0, vCoord1);
	bloom += 0.25 * texture2D(texture0, vCoord2);
	bloom += 0.25 * texture2D(texture0, vCoord3);
	bloom += 0.25 * texture2D(texture0, vCoord4);
	
	bloom -= threshold;
	bloom.r = max(0.0, bloom.r);
	bloom.g = max(0.0, bloom.g);
	bloom.b = max(0.0, bloom.b);
	
	lowp vec4 orig = texture2D(texture0, vCoord0);
	
    gl_FragColor = bloom * bloomFactor + orig * origFactor;
}