
#if (GL_ES && __VERSION__ >= 300) || (!GL_ES && __VERSION__ > 120)
#    define varying in
#    define texture1D texture
#    define texture2D texture
#    define texture3D texture
#    define textureCube texture
#    define textureRect texture
out lowp vec4 glitch_FragColor;
#    define gl_FragColor glitch_FragColor
#endif
#define TEXTURE_1D 0
#define TEXTURE_2D 1
#define TEXTURE_3D 2
#define TEXTURE_CUBE_MAP 3
#define TEXTURE_RECT 4
#ifndef TEXTURE_TYPE
#    define TEXTURE_TYPE TEXTURE_2D
#endif
#if GL_ES && TEXTURE_TYPE == TEXTURE_3D && __VERSION__ < 300
#    extension GL_OES_texture_3D : enable
#elif !GL_ES && TEXTURE_TYPE == TEXTURE_RECT && __VERSION__ < 140
#    extension GL_ARB_texture_rectangle : enable
#endif
#if TEXTURE_TYPE == TEXTURE_3D
uniform lowp    sampler3D sampler;
#elif TEXTURE_TYPE == TEXTURE_CUBE_MAP
uniform lowp    samplerCube sampler;
#elif TEXTURE_TYPE == TEXTURE_RECT
uniform lowp    sampler2DRect sampler;
#elif TEXTURE_TYPE == TEXTURE_1D
uniform lowp    sampler1D sampler;
#else
uniform lowp    sampler2D sampler;
#endif
#if TEXTURE_TYPE == TEXTURE_3D || TEXTURE_TYPE == TEXTURE_CUBE_MAP
varying mediump vec3 vCoord0;
#else
varying mediump vec2 vCoord0;
#endif
void main()
{
#if TEXTURE_TYPE == TEXTURE_3D
    gl_FragColor = texture3D(sampler, vCoord0);
#elif TEXTURE_TYPE == TEXTURE_CUBE_MAP
    gl_FragColor = textureCube(sampler, vCoord0);
#elif TEXTURE_TYPE == TEXTURE_RECT
    gl_FragColor = texture2DRect(sampler, vCoord0);
#elif TEXTURE_TYPE == TEXTURE_1D
    gl_FragColor = texture1D(sampler, vCoord0.x);
#else
    gl_FragColor = texture2D(sampler, vCoord0);
#endif
}