uniform lowp sampler2D TextureSampler;
uniform lowp vec4 DiffuseColor;
uniform lowp sampler2D TextureSamplerMap;

varying highp vec2 vTexCoord0;
varying highp vec2 vTexCoord1;
varying lowp vec4 vColor0;

void main()
{
	lowp vec4 color = texture2D(TextureSampler, vTexCoord0,-8.0);
	lowp float alpha = texture2D(TextureSamplerMap, vTexCoord1,-8.0).a;
	
	if(vTexCoord1.x < 0.0 || vTexCoord1.y < 0.0 || vTexCoord1.x > 1.0 || vTexCoord1.y > 1.0)
	{
		alpha = 0.0;
	}
	
	color.a *= alpha;
	
	gl_FragColor = color;
}
