uniform lowp sampler2D TextureSampler;
uniform lowp vec4 DiffuseColor;
uniform lowp sampler2D TextureSamplerMap;

uniform lowp ivec2 Component;
uniform lowp vec2 Scale;
uniform lowp vec2 MapPoint;
uniform lowp vec2 MapScale;

varying highp vec2 vTexCoord0;
varying lowp vec4 vColor0;

void main()
{
	lowp vec2 uvMap = (vTexCoord0 - MapPoint) * MapScale;
	lowp vec4 pixel = texture2D(TextureSamplerMap, uvMap,-8.0);
	if(uvMap.x < 0.0 || uvMap.y < 0.0 || uvMap.x > 1.0 || uvMap.y > 1.0)
	{
		pixel = vec4(0.5, 0.5, 0.5, 0.5);
	}
	lowp vec2 comp = vec2(pixel[Component.x], pixel[Component.y]);
	lowp vec2 displacement = (comp - vec2(0.5, 0.5)) * Scale;
	gl_FragColor = texture2D(TextureSampler, vTexCoord0 + displacement,-8.0);
}
