
uniform lowp    sampler2D texture0;
uniform lowp    sampler2D texture1;
uniform highp float BumpStrength;
uniform lowp float BlendFactor;
varying mediump vec2 vCoord0;
varying mediump vec2 vCoord1;
varying mediump vec2 vCoord2;
#ifdef ENABLE_COLOR_CORRECTION
	uniform lowp    sampler2D ColorGradingSampler;
	
	const lowp float r_scale = 0.94;
	const lowp float r_off = 0.001875;
#endif
void main()
{
	highp vec4 N1 = texture2D(texture1, vCoord1);
	highp vec4 N2 = texture2D(texture1, vCoord2);
	highp vec2 offset = N1.rg + N2.rg;
	
	offset = 2.0 * offset - 1.0;
	
	offset = offset * (0.004 * BumpStrength);
   	
	lowp vec4 Color = texture2D(texture0, vCoord0 + offset);
	
#ifdef ENABLE_COLOR_CORRECTION
	highp float r = Color.r * 0.0625;
	highp float g = Color.g;
	highp float b = floor(Color.b * 15.99) * 0.0625;
    highp float u = r * r_scale + r_off + b;
    highp float v = g;
    Color = texture2D(ColorGradingSampler, vec2(u, v));
#endif 
	
	lowp vec4 TargetColor = dot(Color, vec4(0.2125, 0.7154, 0.0721, 1.0)) * vec4(0.9, 0.35, 0.0, 1.0);
	
	gl_FragColor = mix(TargetColor, Color, BlendFactor);
}