
#define VERTEX_TEX_COORD
uniform lowp sampler2D 	MainTextureSampler;
uniform lowp sampler2D 	DistortionMap;
#ifdef SPLIT_ALPHA
uniform lowp    sampler2D MainTextureSampler_alpha;
uniform lowp    int       MainTextureSampler_alphachannel;
#endif
#ifndef VERTEX_TEX_COORD
uniform		highp	float	WaterOffsetU;
uniform		highp	float	WaterOffsetV;
#endif
uniform		highp	float	DistortionOffsetU;
uniform		highp	float	DistortionOffsetV;
varying		mediump	vec2 	vCoord0;
varying		lowp	vec4	vColor;
lowp vec4 GetMainTexture(lowp vec2 textCoord)
{
	#ifdef SPLIT_ALPHA	
		return vec4(texture2D(MainTextureSampler, textCoord, -1.0).rgb, texture2D(MainTextureSampler_alpha, textCoord,-1.0)[MainTextureSampler_alphachannel]);
	#else
		return texture2D(MainTextureSampler, textCoord, -1.0);
	#endif
}
void main()
{
#ifdef PROFILE_LOW
	
	#ifdef VERTEX_TEX_COORD
	
		lowp	vec4  WaterColor		= GetMainTexture(vCoord0.xy);
	#else
		lowp	vec4  WaterColor		= GetMainTexture(vCoord0.xy + vec2(WaterOffsetU, WaterOffsetV));
		
	#endif
#else
	lowp	vec2  DistortionColor	= texture2D(DistortionMap, vCoord0.xy + vec2(DistortionOffsetU, DistortionOffsetV), -1.0).rg;
	#ifdef VERTEX_TEX_COORD
		lowp	vec4  WaterColor		= GetMainTexture(vCoord0.xy + DistortionColor);
	#else
		lowp	vec4  WaterColor		= GetMainTexture(vCoord0.xy + DistortionColor + vec2(WaterOffsetU, WaterOffsetV));
	#endif
	
#endif
	
	gl_FragColor = WaterColor * vColor;
#ifdef USE_VERTEX_ALPHA_ONLY
	gl_FragColor.a					= vColor.a;
#endif
}