
#define VERTEX_TEX_COORD
attribute 	highp	vec4 	Position;
attribute 	highp	vec2 	TexCoord0;
#ifdef VERTEX_ALPHA
	attribute 	lowp	vec4 	Color;
#else
	attribute 	lowp	vec3 	Color;
#endif
uniform 	highp	mat4	WorldViewProjection;
#ifdef VERTEX_TEX_COORD
uniform		highp	float	WaterOffsetU;
uniform		highp	float	WaterOffsetV;
#endif
varying		mediump	vec2 	vCoord0;
varying		lowp	vec4	vColor;
void main()
{
#ifdef VERTEX_ALPHA
	vColor			= Color;
#else
	vColor			= vec4(Color,1.0);
#endif
#ifdef VERTEX_TEX_COORD
	vCoord0 		= TexCoord0 + vec2(WaterOffsetU, WaterOffsetV);
#else
	vCoord0 		= TexCoord0;
#endif
	gl_Position		= WorldViewProjection * Position;
}