
uniform lowp sampler2D MapDiffuseSampler;
#ifdef SPLIT_ALPHA
uniform lowp    sampler2D MapDiffuseSampler_alpha;
uniform lowp    int       MapDiffuseSampler_alphachannel;
#endif
varying		mediump	vec2 	vCoord0;
#ifdef LERP_COLOR
uniform 	lowp vec4		SpawnFadeColor;
#endif
#ifdef MUL_COLOR
uniform 	highp vec4		SpawnMulColor;
#endif
void main()
{
	lowp	float  fog_value		= 1.0;
	
	#ifdef SPLIT_ALPHA
		
		lowp vec4 alphaCol = texture2D(MapDiffuseSampler_alpha, vCoord0, -1.0);			
		lowp float alpha = alphaCol.r;
		
		#ifdef SA_USE_CHANEL_ALPHA	
		if(MapDiffuseSampler_alphachannel > 2)
			alpha = alphaCol.a;
		#endif
			
		lowp vec4 WaterColor = vec4(texture2D(MapDiffuseSampler, vCoord0, -1.0).rgb, alpha);
		
	#else
		lowp vec4 WaterColor = texture2D(MapDiffuseSampler, vCoord0, -1.0);
	#endif
#ifdef LERP_COLOR
	WaterColor = mix(WaterColor,SpawnFadeColor,SpawnFadeColor.a);
#endif	
#ifdef MUL_COLOR
	WaterColor = WaterColor * SpawnMulColor;
#endif
	gl_FragColor					= WaterColor;
	
	
}