
#ifdef USE_COLORCORECTION	
	uniform lowp mat4 ColorMatrix;	
#endif
#define VERTEX_TEX_COORD
uniform lowp sampler2D 	WaterMap;
uniform lowp sampler2D 	DistortionMap;
#ifdef SPLIT_ALPHA
uniform lowp    sampler2D WaterMap_alpha;
uniform lowp    int       WaterMap_alphachannel;
#endif
#ifdef USE_FOW
#endif
#ifndef VERTEX_TEX_COORD
uniform		highp	float	WaterOffsetU;
uniform		highp	float	WaterOffsetV;
#endif
uniform		highp	float	DistortionOffsetU;
uniform		highp	float	DistortionOffsetV;
varying		lowp	vec4	vColor;
varying		mediump	vec2 	vCoord0;
#ifdef USE_FOW
#endif
lowp vec4 GetWaterColor(lowp vec2 textCoord)
{
	#ifdef SPLIT_ALPHA	
		
		lowp vec4 alphaCol = texture2D(WaterMap_alpha, textCoord,-1.0);			
		lowp float alpha = alphaCol.r;
		
		#ifdef SA_USE_CHANEL_ALPHA	
		if(WaterMap_alphachannel > 2)
			alpha = alphaCol.a;
		#endif
			
		return vec4(texture2D(WaterMap, textCoord, -1.0).rgb, alpha);
		
	#else
		return texture2D(WaterMap, textCoord, -1.0);
	#endif
}
void main()
{
#ifdef LOW_GPU 
	
	#ifdef VERTEX_TEX_COORD
	
		lowp	vec4  WaterColor		= GetWaterColor(vCoord0.xy);
	#else
		lowp	vec4  WaterColor		= GetWaterColor(vCoord0.xy + vec2(WaterOffsetU, WaterOffsetV));
	#endif
#else
	lowp	vec2  DistortionColor	= texture2D(DistortionMap, vCoord0.xy + vec2(DistortionOffsetU, DistortionOffsetV), -1.0).rg;
	#ifdef VERTEX_TEX_COORD
		lowp	vec4  WaterColor		= GetWaterColor(vCoord0.xy + DistortionColor);
	#else
		lowp	vec4  WaterColor		= GetWaterColor(vCoord0.xy + DistortionColor + vec2(WaterOffsetU, WaterOffsetV));
	#endif
	
#endif
	
#ifdef USE_FOW
	gl_FragColor					= WaterColor * vColor;
#else
	gl_FragColor					= WaterColor * vColor;
#endif
#ifdef USE_VERTEX_ALPHA
	gl_FragColor.a					= vColor.a;
#endif
#ifdef USE_COLORCORECTION
	gl_FragColor = ColorMatrix * gl_FragColor;
#endif 
}