
#ifndef PROFILE_HIGH
	#ifdef USE_GROUND_CLOUDS
		#undef USE_GROUND_CLOUDS
	#endif
#endif
#ifdef LOW_GPU
	#ifdef USE_SELECTION
		#undef USE_SELECTION
	#endif
#endif
#ifdef USE_COLORCORECTION	
	uniform lowp mat4 ColorMatrix;
#endif
uniform lowp sampler2D 	WaterMap;
#ifdef SPLIT_ALPHA
uniform lowp    sampler2D WaterMap_alpha;
uniform lowp    int       WaterMap_alphachannel;
#endif
uniform		highp	float	WaterOffsetU;
uniform		highp	float	WaterOffsetV;
varying		lowp	vec4	vColor;
varying		highp	vec2 	vCoord0;
#ifndef DIFFUSECOLOR

#ifndef CLOUDS_VERTEX_FS
#define CLOUDS_VERTEX_FS
#ifdef USE_GROUND_CLOUDS
uniform lowp sampler2D CloudTexture;
lowp vec3 GetCloudColor(mediump vec2 tex_uv)
{
	return texture2D(CloudTexture,tex_uv).xyz * 2.00787;
}
#ifndef NO_CLOUD_UV
	varying mediump vec2 cloud_uv_tex_coord;
	mediump vec2 GetCloudUV()
	{
		return cloud_uv_tex_coord;
	}
	lowp vec3 GetCloudColor()
	{
		return GetCloudColor(GetCloudUV());
	}
#endif
#else 
lowp vec3 GetCloudColor(mediump vec2 tex_uv)
{
	return vec3(1.0);
}
lowp vec3 GetCloudColor()
{
	return vec3(1.0);
}
#endif 
#endif 

#endif
#ifdef USE_SELECTION
uniform highp float kSelectionSin;
#endif
void main()
{
	#ifdef SPLIT_ALPHA	
		
		
		
		
		lowp vec4 alphaCol = texture2D(WaterMap_alpha, vCoord0.xy/* + DistortionColor.rg + vec2(WaterOffsetU, WaterOffsetV)*/,-1.0);
				
		lowp	vec4  WaterColor		= texture2D(WaterMap, vCoord0.xy /*+ DistortionColor.rg + vec2(WaterOffsetU, WaterOffsetV)/**/, -1.0);
		
		if(WaterMap_alphachannel<2)
		WaterColor.a=alphaCol.r;
		
		
	#else	
		
		lowp	vec4  WaterColor		= texture2D(WaterMap, vCoord0.xy /*+ DistortionColor.rg + vec2(WaterOffsetU, WaterOffsetV)/**/, -1.0);
	#endif
#if defined(USE_GROUND_CLOUDS) && !defined (DIFFUSECOLOR)
	
	WaterColor.xyz *= GetCloudColor();
	
#endif
	gl_FragColor					= WaterColor * vColor;
	#ifdef USE_SELECTION
		gl_FragColor = mix(gl_FragColor,gl_FragColor * 0.5,kSelectionSin);
	#endif
	
#ifdef USE_COLORCORECTION
	gl_FragColor = ColorMatrix * gl_FragColor;
#endif 
}