
#ifdef USE_COLORCORECTION	
	uniform lowp mat4 ColorMatrix;	
#endif
#ifndef UNIT_SHADOW
uniform lowp   sampler2D sampler0;
#endif
#ifdef SPLIT_ALPHA
uniform lowp    sampler2D sampler0_alpha;
uniform lowp    int       sampler0_alphachannel;
#endif
#ifdef GEOMETRY_COLOR
	varying lowp vec4 vColor0;
#endif
#ifdef PLAYER_COLOR
	varying	highp float fUcol;
	uniform mediump vec4 player_colors[8];
#endif 
#ifndef UNIT_SHADOW
	varying mediump vec2 vTexCoord0;
#endif 
#ifdef USE_NORMAL
	
	
	
	varying lowp vec3 vE;
	varying lowp vec3 vN;
	
	uniform lowp sampler2D SphericalMap_Diffuse_Refl;
#ifdef SPLIT_ALPHA
	uniform lowp sampler2D 		SphericalMap_Diffuse_Refl_alpha;
	uniform lowp    int       	SphericalMap_Diffuse_Refl_alphachannel;
#endif
	
#ifdef _WIN32
	uniform mediump float specPower;
	uniform mediump float specMultiplier;
	uniform mediump float reflMultiplier;
	uniform mediump float dfMultiplier;
	
	uniform lowp float fresnelWidth;
	uniform lowp float fresnelMultiplier;	
	
	uniform lowp 	float ambient;
	
	uniform lowp 	vec3 units_LightDir;
	uniform lowp 	float shadingMode;
	
	uniform lowp 	float useNewSpecReflFormula;
	uniform lowp 	vec3 fresnelCol;	
#	else
# 		define shadingMode 				1.0
# 		define units_LightDir 			normalize(vec3(0.5,-1.0,1.0))
# 		define ambient					0.0
# 		define dfMultiplier				2.52	
# 		define reflMultiplier			1.45
# 		define fresnelMultiplier		0.4
# 		define fresnelWidth				0.25
# 		define fresnelCol 				vec3(1.0,1.0,1.0)	
# 		define useNewSpecReflFormula  	1.0	
# 		define specMultiplier			0.7
# 		define specPower			2.5
#	endif 
#endif 
void main()
{
#ifdef UNIT_SHADOW
	
	gl_FragColor = vec4(vec3(0.0196,0.1529,0.3568),0.5);
#else
	#ifdef SPLIT_ALPHA
		
		lowp vec4 alphaCol = texture2D(sampler0_alpha, vTexCoord0, -1.0);			
		lowp float alpha = alphaCol.r;
		
		#ifdef SA_USE_CHANEL_ALPHA	
		if(sampler0_alphachannel > 2)
			alpha = alphaCol.a;
		#endif
			
		lowp vec4 texColor = vec4(texture2D(sampler0, vTexCoord0, -1.0).rgb, alpha);
		
	#else
		lowp vec4 texColor = texture2D(sampler0, vTexCoord0, -1.0);
	#endif
#ifdef PLAYER_COLOR
	
	#ifdef POWERVR_GPU			
	int ind = int(fUcol);
	lowp vec4 pcolor = player_colors[ind];
	#else
		
		
			
			
			
		
			lowp vec4 pcolor = player_colors[7];
			if(fUcol < 1.0)
				pcolor = player_colors[0];
			else if(fUcol < 2.0)
				pcolor = player_colors[1];
			else if(fUcol < 3.0)
				pcolor = player_colors[2];
			else if(fUcol < 4.0)
				pcolor = player_colors[3];
			else if(fUcol < 5.0)
				pcolor = player_colors[4];
			else if(fUcol < 6.0)
				pcolor = player_colors[5];
			else if(fUcol < 7.0)
				pcolor = player_colors[6];
		#endif 
		
	
	
		
	#ifdef GEOMETRY_COLOR
		gl_FragColor = texColor * vColor0;
	#else
		gl_FragColor = texColor;
	#endif
	
#else 
	#ifdef GEOMETRY_COLOR
		gl_FragColor = texColor * vColor0;		
	#else
		gl_FragColor = texColor;
	#endif
#endif
#ifdef USE_NORMAL	
	lowp vec3 E = vE;
	lowp vec3 N = vN;
	lowp vec3 texCol = gl_FragColor.xyz;
	
	
	lowp float specMask = texColor.a;		
	
	lowp vec3 shadeBase;
	mediump vec3 dfColor;
	
		
		mediump vec3 sD = N + vec3(0.0, 0.0, 1.0);		
		
		lowp float  kD = 0.5 / sqrt(dot(sD, sD));		
		
		lowp vec2 SphereUV_diffuse = sD.xy * kD + 0.5;	
		
		dfColor = texture2D(SphericalMap_Diffuse_Refl, SphereUV_diffuse).rgb * dfMultiplier;
		dfColor = min(dfColor, 1.0);
		shadeBase = texCol * dfColor;
	
	
	shadeBase = shadeBase + (texCol * ambient);
	
	lowp vec3 LR = reflect(-units_LightDir, N); 
	lowp float specular = clamp(pow(dot(LR, E), specPower),0.0,1.0);
	
		specular = specular * specMultiplier;
	
	
    lowp vec3 sR = reflect(-E, N) + vec3(0.0, 0.0, 1.0);
    
    lowp float  kF = 0.5 / sqrt(dot(sR, sR));
    	
    lowp vec2 SphereUV_refl = sR.xy * kF + 0.5;
    
#ifdef SPLIT_ALPHA
		
		lowp vec4 alphaCol2 = texture2D(SphericalMap_Diffuse_Refl_alpha, SphereUV_refl);			
		lowp float alpha2 = alphaCol2.r;
		
		#ifdef SA_USE_CHANEL_ALPHA	
		if(SphericalMap_Diffuse_Refl_alphachannel > 2)
			alpha2 = alphaCol2.a;
		#endif
				
		lowp vec3 reflection = vec3(alpha2) * (specMask * reflMultiplier);
		
#else        	
	lowp vec3 reflection = texture2D(SphericalMap_Diffuse_Refl, SphereUV_refl).aaa * (specMask * reflMultiplier);
#endif
		
	
		
		specular = mix(specular, 0.0, min(reflection.r,1.0));
		
		gl_FragColor = vec4(shadeBase + specular*texCol.rgb + reflection, 1.0);				
#ifdef USE_SPECULAR_MASK
	gl_FragColor = mix(texColor,gl_FragColor,clamp(specMask * 10000.0,0.0,1.0));
#endif
	
	
	
	
	
	
	
	lowp float f = 1.0 - max(dot(N, E), 0.0);
	f = smoothstep(1.0 - fresnelWidth, 1.0, f);
	f = f * fresnelMultiplier * specMask * 1.5;
		
	
	lowp vec3 fresnel = fresnelCol * f;
	
#ifdef PLAYER_COLOR	
	gl_FragColor = mix(gl_FragColor,pcolor,f);
	
	
	/*#ifdef _WIN32
		gl_FragColor = vec4(gl_FragColor.rgb*(1.0-f) + fresnel,1.0);
	#endif*/
	
	
#else
	gl_FragColor = vec4(gl_FragColor.rgb*(1.0-f) + fresnel,1.0); 
#endif
	
#endif
#endif 
#ifdef USE_COLORCORECTION
	gl_FragColor = ColorMatrix * gl_FragColor;
#endif 
}