
attribute highp vec4 Vertex;
attribute mediump vec2 TexCoord0;
attribute mediump vec2 TexCoord1;
#ifdef USE_NORMAL
attribute mediump vec3 Normal;
#endif
#ifdef GEOMETRY_COLOR
	attribute lowp vec4 Color0;
#endif
uniform highp mat4 MatViewProjection;
uniform highp vec4 bonequat0[124];
#ifndef UNIT_SHADOW
	varying	mediump vec2 vTexCoord0;
#endif
#ifdef GEOMETRY_COLOR
	varying	lowp vec4 vColor0;
#endif
#ifdef PLAYER_COLOR
	varying	highp float fUcol;
#endif
#ifdef _WIN32
const lowp float czero = 0.0;
const lowp float cone = 1.0;
#else
#	define czero 0.0
#	define cone 1.0
#endif
#ifdef USE_NORMAL
	
	
	uniform highp vec3 camera_pos;
	
	varying highp vec3 vE;
	varying highp vec3 vN;
#endif
void main(void)
{
	lowp int index1 = int(TexCoord1.x);
	highp vec4 a = bonequat0[index1];
	highp vec4 b = bonequat0[index1 + 1];
	highp vec4 c = bonequat0[index1 + 2];
	highp mat4 world = mat4 ( a.x, b.x, c.x, czero, 
							a.y, b.y, c.y, czero, 
							a.z, b.z, c.z, czero,
							a.w, b.w, c.w, cone );
	
	mediump mat4 mworld = mat4 ( a.x, b.x, c.x, 0.0, 
					a.y, b.y, c.y, 0.0, 
					a.z, b.z, c.z, 0.0,
					a.w, b.w, c.w, 1.0 );
#ifndef UNIT_SHADOW
	vTexCoord0 = TexCoord0;
#endif
#ifdef GEOMETRY_COLOR
	vColor0 = Color0;
#endif
#ifdef PLAYER_COLOR
	fUcol = TexCoord1.y;
#endif
#ifdef USE_NORMAL
	
	vE = normalize(camera_pos - (mworld * Vertex).xyz);
	vN = normalize((mworld * vec4(Normal,0.0)).xyz);
#endif
#ifdef UNIT_SHADOW
	highp vec3 world_pos = (world * Vertex).xyz;
	highp vec3 ld = normalize(vec3(-0.5,-1.0,1.0));
	world_pos = world_pos - ld * (world_pos.z / ld.z);
	world_pos.z += 0.5;
	gl_Position = ( MatViewProjection ) * vec4(world_pos,1.0);
#else
	gl_Position = ( MatViewProjection * world ) * Vertex;
#endif
}