
#ifndef PROFILE_HIGH
	#ifdef USE_GROUND_CLOUDS
		#undef USE_GROUND_CLOUDS
	#endif
#endif
attribute	highp	vec4	Position;
attribute	highp	vec2	Coord0;
attribute	lowp	vec4	Color;

#ifndef _MATRIXV
#define _MATRIXV
uniform 	highp	mat4	WorldViewProjection;
uniform 	highp	mat4	WorldViewTransposed;
uniform		highp	mat4	matworld;
#endif

varying		lowp	vec4	vColor;
varying		mediump	vec2	vCoord0;

#ifdef USE_GROUND_CLOUDS
#ifndef CLOUDS_VERTEX_SH
#define CLOUDS_VERTEX_SH
uniform highp vec3 		WorldBox;
uniform highp float		kTimeMinutes;
#ifdef NO_CLOUD_UV
	mediump vec2 ComputeCloudUV(highp vec2 pos_xy)
	{
		mediump vec2 tex_coord = (pos_xy / WorldBox.xy) * 2.0 + 0.5;
		return tex_coord + vec2(0.0,1.0) * kTimeMinutes;
	}
	mediump vec2 GetCloudsUV(highp mat4 world_transform,highp vec4 vpos)
	{
		return ComputeCloudUV((world_transform * vpos).xy);
	}
#else
	varying mediump vec2 cloud_uv_tex_coord;
	void ComputeCloudUV(highp vec2 pos_xy)
	{
		mediump vec2 tex_coord = (pos_xy / WorldBox.xy) * 2.0 + 0.5;
		cloud_uv_tex_coord = tex_coord + vec2(0.0,1.0) * kTimeMinutes;
	}
	void GetCloudsUV(highp mat4 world_transform,highp vec4 vpos)
	{
		ComputeCloudUV((world_transform * vpos).xy);
	}
#endif 
#endif 
#endif 

void main()
{ 
	vCoord0		= Coord0;
	vColor		= Color;
	
	
	
	gl_Position	= WorldViewProjection * Position;
#ifdef USE_GROUND_CLOUDS
	GetCloudsUV(matworld,Position);
#endif
}