
#ifndef PROFILE_HIGH
	#ifdef USE_GROUND_CLOUDS
		#undef USE_GROUND_CLOUDS
	#endif
#endif

#ifndef _VERTEX_BASICS
#define _VERTEX_BASICS
attribute 	highp	vec4 	Position;

#ifndef _MATRIXV
#define _MATRIXV
uniform 	highp	mat4	WorldViewProjection;
uniform 	highp	mat4	WorldViewTransposed;
uniform		highp	mat4	matworld;
#endif

void		setWVP()
{
	gl_Position	= WorldViewProjection * Position;
}
highp vec4	getWorldPos()
{
	return (matworld * Position);
}
#endif

attribute	mediump	vec2	TexCoord0;
attribute	mediump	vec2	TexCoord1;
#ifdef SNOW
attribute	mediump	vec2	TexCoord2;
#endif
attribute	lowp	vec3	Color;
varying		mediump	vec2	vCoord0;
varying		mediump	vec2	vCoord1;
#ifdef SNOW
	varying		mediump	vec2	vCoord2;
#endif
varying		lowp	vec3	vColor;

#ifdef USE_GROUND_CLOUDS
#ifndef CLOUDS_VERTEX_SH
#define CLOUDS_VERTEX_SH
uniform highp vec3 		WorldBox;
uniform highp float		kTimeMinutes;
#ifdef NO_CLOUD_UV
	mediump vec2 ComputeCloudUV(highp vec2 pos_xy)
	{
		mediump vec2 tex_coord = (pos_xy / WorldBox.xy) * 2.0 + 0.5;
		return tex_coord + vec2(0.0,1.0) * kTimeMinutes;
	}
	mediump vec2 GetCloudsUV(highp mat4 world_transform,highp vec4 vpos)
	{
		return ComputeCloudUV((world_transform * vpos).xy);
	}
#else
	varying mediump vec2 cloud_uv_tex_coord;
	void ComputeCloudUV(highp vec2 pos_xy)
	{
		mediump vec2 tex_coord = (pos_xy / WorldBox.xy) * 2.0 + 0.5;
		cloud_uv_tex_coord = tex_coord + vec2(0.0,1.0) * kTimeMinutes;
	}
	void GetCloudsUV(highp mat4 world_transform,highp vec4 vpos)
	{
		ComputeCloudUV((world_transform * vpos).xy);
	}
#endif 
#endif 
#endif 

void main()
{
	
	
	vCoord0		= TexCoord0;
	vCoord1		= TexCoord1;
	
#ifdef SNOW
	vCoord2		= TexCoord2;
#endif
	vColor		= Color;
	setWVP();
#ifdef USE_GROUND_CLOUDS
	GetCloudsUV(matworld,Position);
#endif
}