
uniform    sampler2D texture0;
varying lowp vec2 vCoord11;
varying lowp vec2 dir;
uniform highp float sampleDist;
const highp float sampleStrength = 2.2;
#ifdef ENABLE_COLOR_CORRECTION
	uniform    sampler2D ColorGradingSampler;
	
	const lowp float r_scale = 0.94;
	const lowp float r_off = 0.001875;
#endif
const lowp float c1 = 0.01;
const lowp float c2 = 0.03;
const lowp float c3 = 0.08;
const lowp float c4 = 1.0 / 7.0;
void main()
{
    highp vec4 color = texture2D(texture0, vCoord11);
    highp vec2 uv = vCoord11;
 
    lowp vec4 sum = color;
    
    lowp vec2 uv1 = c1 * dir;
    lowp vec2 uv2 = c2 * dir;
    lowp vec2 uv3 = c3 * dir;
	
    sum += texture2D( texture0, uv - uv1);
    sum += texture2D( texture0, uv - uv2);
    sum += texture2D( texture0, uv - uv3);
    sum += texture2D( texture0, uv + uv1);
    sum += texture2D( texture0, uv + uv2);
    sum += texture2D( texture0, uv + uv3);
         
	 
    sum *= c4;	
#ifdef ENABLE_COLOR_CORRECTION
	lowp vec4 Color = sum;
	highp float r = Color.r * 0.0625;
	highp float g = Color.g;
	highp float b = floor(Color.b * 15.99) * 0.0625;
    highp float u = r * r_scale + r_off + b;
    highp float v = g;
    gl_FragColor = texture2D(ColorGradingSampler, vec2(u, v));
#else
    gl_FragColor = sum;
#endif
 }