
uniform lowp    sampler2D texture0;
varying highp vec2 vCoord11;
uniform highp vec2 center;
uniform highp float timeFactor;
uniform highp vec3 shockParams; 
 
void main()
{
	highp vec2 uv = vCoord11.xy;
	highp vec2 texCoord = uv;
	
	highp float distance = length(uv - center);
	
	if ( (distance <= (timeFactor + shockParams.z)) &&
       (distance >= (timeFactor - shockParams.z)) )
	{
		highp float diff = (distance - timeFactor);
		highp float powDiff = 1.0 - pow(abs(diff * shockParams.x), shockParams.y);
		
		highp float diffTime = diff  * powDiff;
		highp vec2 diffUV = normalize(uv - center);
		
		texCoord = uv + (diffUV * diffTime);
	}
	gl_FragColor = texture2D(texture0, texCoord);
 }