
uniform lowp sampler2D             DiffuseMap;
#ifdef SPLIT_ALPHA
uniform lowp    sampler2D DiffuseMap_alpha;
uniform lowp    int       DiffuseMap_alphachannel;
#endif
varying		lowp	vec4	vColor;
varying		mediump	vec2	vCoord0;
#ifdef USE_FADE
uniform mediump float Fade;
#endif
 
void main()
{
    lowp vec4 _MapDiffuse1;
	#ifdef SPLIT_ALPHA
		
		lowp vec4 alphaCol = texture2D(DiffuseMap_alpha, vCoord0,-1.0);			
		lowp float alpha = alphaCol.r;
		
		#ifdef SA_USE_CHANEL_ALPHA	
		if(DiffuseMap_alphachannel > 2)
			alpha = alphaCol.a;
		#endif
			
		_MapDiffuse1 = vec4(texture2D(DiffuseMap, vCoord0,-1.0).rgb, alpha);
		
	#else
		_MapDiffuse1 = texture2D(DiffuseMap, vCoord0,-1.0);
	#endif
#ifdef USE_FADE
    gl_FragColor = (_MapDiffuse1 * vColor) * Fade;
#else
	gl_FragColor = (_MapDiffuse1 * vColor);
#endif
} 