
#ifndef PROFILE_HIGH
	#ifdef USE_GROUND_CLOUDS
		#undef USE_GROUND_CLOUDS
	#endif
#endif
uniform lowp sampler2D             MapDiffuseSampler;
#ifdef SPLIT_ALPHA
uniform lowp    sampler2D MapDiffuseSampler_alpha;
uniform lowp    int       MapDiffuseSampler_alphachannel;
#endif
varying	  mediump    	vec2     vCoord0;
varying   lowp    		vec4     vColor0;
varying 	highp vec3			vNormal;
varying 	highp vec3		vEye;
uniform lowp float AlphaMultiplier;
 
/*
#ifdef ENABLE_CLOUDS

#ifndef CLOUDS_VERTEX_FS
#define CLOUDS_VERTEX_FS
#ifdef USE_GROUND_CLOUDS
uniform lowp sampler2D CloudTexture;
lowp vec3 GetCloudColor(mediump vec2 tex_uv)
{
	return texture2D(CloudTexture,tex_uv).xyz * 2.00787;
}
#ifndef NO_CLOUD_UV
	varying mediump vec2 cloud_uv_tex_coord;
	mediump vec2 GetCloudUV()
	{
		return cloud_uv_tex_coord;
	}
	lowp vec3 GetCloudColor()
	{
		return GetCloudColor(GetCloudUV());
	}
#endif
#else 
lowp vec3 GetCloudColor(mediump vec2 tex_uv)
{
	return vec3(1.0);
}
lowp vec3 GetCloudColor()
{
	return vec3(1.0);
}
#endif 
#endif 

#endif
*/
uniform lowp sampler2D SphericalMap_Diffuse_Refl2;
#ifdef SPLIT_ALPHA
	uniform lowp sampler2D 		SphericalMap_Diffuse_Refl2_alpha;
	uniform lowp    int       	SphericalMap_Diffuse_Refl2_alphachannel;
#endif
#define units_LightDir 				normalize(vec3(-0.3,-1.0,0.7))
#define shadingMode					1.0
#define ambient						0.0
#define dfMultiplier				2.52
#define reflMultiplier				1.45
#define fresnelMultiplier			0.4
#define fresnelWidth				0.25
#define fresnelCol					vec3(1.0,1.0,1.0)
#define useNewSpecReflFormula 		1.0
#define specMultiplier				0.7
#define specPower					2.5
void main()
{	
    lowp vec4 _MapDiffuse1;
	
	#ifdef SPLIT_ALPHA
		
		_MapDiffuse1 = vec4(texture2D(MapDiffuseSampler, vCoord0,-1.0).rgb,
							  texture2D(MapDiffuseSampler_alpha, vCoord0,-1.0).r);
		
	#else
		_MapDiffuse1 = texture2D(MapDiffuseSampler, vCoord0,-1.0);
	#endif
	
	_MapDiffuse1 = _MapDiffuse1 * vColor0;
	
/*
#if defined(ENABLE_CLOUDS) && defined(USE_GROUND_CLOUDS)
	gl_FragColor = _MapDiffuse1 * vec4(GetCloudColor(),1.0);
#else
	gl_FragColor = _MapDiffuse1;
#endif
*/
	mediump vec3 N = normalize(vNormal);
	mediump vec3 E = normalize(vEye);
	gl_FragColor.xyz = _MapDiffuse1.xyz;
	
	lowp vec3 texCol = _MapDiffuse1.xyz;
	
	
	lowp float specMask = _MapDiffuse1.a;		
	
	lowp vec3 shadeBase;
	mediump vec3 dfColor;
	
	
		
		mediump vec3 sD = N + vec3(0.0, 0.0, 1.0);		
		
		lowp float  kD = 0.5 / sqrt(dot(sD, sD));		
		
		lowp vec2 SphereUV_diffuse = sD.xy * kD + 0.5;	
		
		dfColor = texture2D(SphericalMap_Diffuse_Refl2, SphereUV_diffuse).rgb * dfMultiplier;
		dfColor = min(dfColor, 1.0);
		shadeBase = texCol * dfColor;
	
	
	
		
		
		
		
	
	
	
		
		
		
		
	
	
	
	shadeBase = shadeBase + (texCol * ambient);
	
	lowp vec3 LR = reflect(-units_LightDir, N); 
	
	lowp float specular = clamp(pow(dot(LR, E), specPower),0.2,1.0);
	
	
	
	
		specular = specular * specMultiplier;
	
	
	
	
	
	
	
    lowp vec3 sR = reflect(-E, N) + vec3(0.0, 0.0, 1.0);
    
    lowp float  kF = 0.5 / sqrt(dot(sR, sR));
    	
    lowp vec2 SphereUV_refl = sR.xy * kF + 0.5;
    
#ifdef SPLIT_ALPHA
	
	lowp vec3 reflection = vec3(texture2D(SphericalMap_Diffuse_Refl2_alpha, SphereUV_refl).r) * (specMask * reflMultiplier);
	
#else        	
	lowp vec3 reflection = texture2D(SphericalMap_Diffuse_Refl2, SphereUV_refl).aaa * (specMask * reflMultiplier);
#endif
		
	
	
	
	
		
		specular = mix(specular, 0.0, min(reflection.r,1.0));
		
		gl_FragColor = vec4(shadeBase + specular*texCol.rgb + reflection, 1.0);				
	
	
	
	
	
	
	
	
	
	
	
	
	lowp float f = 1.0 - max(dot(N, E), 0.0);
	f = smoothstep(1.0 - fresnelWidth, 1.0, f);
	f = f * fresnelMultiplier;
	
	lowp vec3 fresnel = fresnelCol * f;
	gl_FragColor = vec4(gl_FragColor.rgb*(1.0-f) + fresnel,AlphaMultiplier);
	
	
	
} 