
#ifndef PROFILE_HIGH
	#ifdef USE_GROUND_CLOUDS
		#undef USE_GROUND_CLOUDS
	#endif
#endif
attribute highp		vec4   Vertex;
attribute mediump	vec2   TexCoord0;
attribute lowp   	vec4   Color0;
attribute highp 	vec3	Normal;
uniform   highp   mat4 WorldViewProjectionMatrix;
uniform   highp   mat4 matworld;
uniform highp vec3 camera_pos;
varying	  mediump    vec2     vCoord0;
varying   lowp   	 vec4     vColor0;
#ifndef PROFILE_HIGH
varying 	mediump vec3		vNormal;
#else
varying 	highp vec3		vNormal;
#endif
varying 	highp vec3		vEye;
/*#ifdef ENABLE_CLOUDS

#ifdef USE_GROUND_CLOUDS
#ifndef CLOUDS_VERTEX_SH
#define CLOUDS_VERTEX_SH
uniform highp vec3 		WorldBox;
uniform highp float		kTimeMinutes;
#ifdef NO_CLOUD_UV
	mediump vec2 ComputeCloudUV(highp vec2 pos_xy)
	{
		mediump vec2 tex_coord = (pos_xy / WorldBox.xy) * 2.0 + 0.5;
		return tex_coord + vec2(0.0,1.0) * kTimeMinutes;
	}
	mediump vec2 GetCloudsUV(highp mat4 world_transform,highp vec4 vpos)
	{
		return ComputeCloudUV((world_transform * vpos).xy);
	}
#else
	varying mediump vec2 cloud_uv_tex_coord;
	void ComputeCloudUV(highp vec2 pos_xy)
	{
		mediump vec2 tex_coord = (pos_xy / WorldBox.xy) * 2.0 + 0.5;
		cloud_uv_tex_coord = tex_coord + vec2(0.0,1.0) * kTimeMinutes;
	}
	void GetCloudsUV(highp mat4 world_transform,highp vec4 vpos)
	{
		ComputeCloudUV((world_transform * vpos).xy);
	}
#endif 
#endif 
#endif 

#endif*/
 
void main()
{
	vCoord0 = TexCoord0;
	vColor0 = Color0;
	vNormal = normalize((( matworld ) * vec4(Normal,0.0)).xyz);
	highp vec3 world_position = (( matworld ) * vec4(Vertex.xyz,1.0)).xyz;
	vEye = normalize(camera_pos - world_position);
	
	gl_Position = WorldViewProjectionMatrix * Vertex;
/*
#ifdef ENABLE_CLOUDS
	#ifdef USE_GROUND_CLOUDS
		GetCloudsUV(matworld,Vertex);
	#endif
#endif
*/
} 