
uniform	lowp	sampler2D	texture0;
uniform highp 	sampler2D	DepthSampler;
uniform highp 	vec2 		camnearandfar;
varying	mediump vec2 		vCoord0;
const highp vec2 pixel_width = vec2(1.0 / 1024.0,0.0) * 1.5;
const highp vec2 pixel_height = vec2(0.0,1.0 / 768.0) * 1.5;
const highp vec2 pixel_size = pixel_width + pixel_height;
const highp vec2 pixel_inv_size = pixel_width - pixel_height;
uniform highp float kCamZoom;
uniform highp float kCamTilt;
highp float linear_depth(highp float z)  
{
    
    
    return z;
}
void main()
{
	highp float z = texture2D(DepthSampler,vCoord0).r;
	
	highp float uv = z;
	highp float pivot = 0.38215;
	highp float span = mix(0.032,0.16,kCamZoom);
	highp float ds = clamp(abs(uv - pivot) / span - 0.26 * kCamTilt,0.0,1.0);
	highp float factor = 1.0 - pow(ds,mix(2.0,1.3,kCamTilt));
	/*highp float down_pivot = 0.45;
	highp float up_pivot = 0.35;
	highp float pow_factor = mix(2.0,8.0,kCamTilt);
	highp float down_factor = pow(clamp(uv * (1.0 / down_pivot),0.0,1.0),pow_factor);
	highp float up_factor = pow(clamp((1.0 - uv) * (1.0 / up_pivot),0.0,1.0),pow_factor);
	highp float factor = up_factor * down_factor;*/
	
	/*highp float a = 1.0;
	highp float b = 1.0;
	highp float c = 1.0;*/
	mediump vec3 col = texture2D(texture0, vCoord0).rgb; 
	mediump vec3 oc = col;
	col += texture2D(texture0, vCoord0 + pixel_width).rgb; 
	col += texture2D(texture0, vCoord0 - pixel_width).rgb; 
	col += texture2D(texture0, vCoord0 + pixel_height).rgb; 
	col += texture2D(texture0, vCoord0 - pixel_height).rgb; 
	col += texture2D(texture0, vCoord0 + pixel_size).rgb; 
	col += texture2D(texture0, vCoord0 - pixel_size).rgb; 
	col += texture2D(texture0, vCoord0 + pixel_inv_size).rgb; 
	col += texture2D(texture0, vCoord0 - pixel_inv_size).rgb; 
	
	col += texture2D(texture0, vCoord0 + pixel_width * 2.0).rgb; 
	col += texture2D(texture0, vCoord0 - pixel_width * 2.0).rgb; 
	col += texture2D(texture0, vCoord0 + pixel_height * 2.0).rgb; 
	col += texture2D(texture0, vCoord0 - pixel_height * 2.0).rgb; 
	/*
	col += texture2D(texture0, vCoord0 + pixel_size * 2.0).rgb; 
	col += texture2D(texture0, vCoord0 - pixel_size * 2.0).rgb; 
	col += texture2D(texture0, vCoord0 + pixel_inv_size * 2.0).rgb; 
	col += texture2D(texture0, vCoord0 - pixel_inv_size * 2.0).rgb; 
	*/
	col /= 12.0;
	col = mix(clamp(col,vec3(0.0),vec3(1.0)),oc,factor);
	gl_FragColor = vec4(col,1.0);
	
	
}