
uniform sampler2D             MapDiffuseSampler;
varying		mediump    vec2     vCoord0;
varying		lowp    vec4     vColor0;
varying		mediump vec4 projectionCoord;
varying		mediump vec3 noiseCoord;
 
void main()
{
  mediump float inv_w = 1.0 / projectionCoord.w;
  mediump vec2 finalCoord = projectionCoord.xy * inv_w;
  mediump vec3 noiseNormal = (texture2D(MapDiffuseSampler, (noiseCoord.xy * 0.2)).rgb - 0.5).rbg;
  finalCoord += noiseNormal.xz;
  gl_FragColor = texture2D(MapDiffuseSampler, finalCoord) * vColor0;
} 