
#define FOG
attribute highp		vec4   Vertex;
attribute mediump	vec2   TexCoord0;
attribute lowp	   vec4   Color0;
uniform   highp   mat4 WorldViewProjectionMatrix;
uniform   highp   float TexFactorX;
uniform   highp   float TexFactorY;
uniform   highp   float FadeFactor;
varying	  highp    vec2     vCoord0;
varying   lowp    vec4     vColor0;
#ifdef FOG
uniform highp mat4 WorldViewT;
varying lowp float fogFactor;
uniform highp vec2 fogstartend;
#endif 
void main()
{
	gl_Position = WorldViewProjectionMatrix * Vertex;
	vCoord0 = TexCoord0;
	vCoord0.x += TexFactorX;
	vCoord0.y += TexFactorY;
	
	vColor0 = Color0 * FadeFactor;
	
#ifdef FOG
    mediump float depth = dot(WorldViewT[2], vec4(Vertex.xyz,1));
    fogFactor = clamp((depth - fogstartend[0]) / (fogstartend[1] - fogstartend[0]), 0.0, 1.0);
#endif
} 