
attribute highp		vec4   Vertex;
attribute mediump	vec2   TexCoord0;
attribute lowp   vec4   Color0;
uniform   highp   mat4 WorldViewProjectionMatrix;
uniform   highp   float TexFactorX;
uniform   highp   float TexFactorY;
varying	 	mediump    	vec2     vCoord0;
varying  	lowp    	vec4     vColor0;
varying		mediump 	vec4 projectionCoord;
varying		mediump 	vec3 noiseCoord;
 
void main()
{
	gl_Position = WorldViewProjectionMatrix * Vertex;
	vCoord0 = TexCoord0;
	vCoord0.x += TexFactorX;
	vCoord0.y += TexFactorY;
	
	lowp mat4 scalemat = mat4(0.5,   0.0,   0.0, 0.5, 
	                           0.0,   -0.5,  0.0, 0.5,
			                   0.0,   0.0,   0.5, 0.5,
			                   0.0,   0.0,   0.0, 1.0);
	projectionCoord = scalemat * gl_Position;
	noiseCoord.xy = (TexCoord0 + vec2(2.0 * TexFactorY)) * 1.0;
	noiseCoord.z = TexFactorY * (sin(TexFactorY) + sin(TexFactorY*2.0)/2.0 + sin(TexFactorY*4.0)/4.0);
	vColor0 = Color0;
	
} 