
uniform lowp    sampler2D texture1;
uniform lowp    sampler2D texture2;
#if defined(SPLIT_ALPHA1) || defined(SPLIT_ALPHA)
uniform lowp    sampler2D texture1_alpha;
uniform lowp    int       texture1_alphachannel;
#endif
#if defined(SPLIT_ALPHA2) || defined(SPLIT_ALPHA)
uniform lowp    sampler2D texture2_alpha;
uniform lowp    int       texture2_alphachannel;
#endif
varying mediump vec2 vCoord0;
varying	lowp vec4 vColor0;
void main()
{	
#if defined(SPLIT_ALPHA1) || defined(SPLIT_ALPHA)
	lowp vec4 alphaCol = texture2D(texture1_alpha, vCoord0);			
	lowp float alpha = alphaCol.r;
	
	#ifdef SA_USE_CHANEL_ALPHA		
	if(texture1_alphachannel > 2)
		alpha = alphaCol.a;
	#endif
		
	lowp vec4 color1 = vec4(texture2D(texture1, vCoord0).rgb, alpha);
#else
	lowp vec4 color1 = texture2D(texture1, vCoord0);
#endif
	
#if defined(SPLIT_ALPHA2) || defined(SPLIT_ALPHA)
	lowp vec4 alphaCol2 = texture2D(texture2_alpha, vCoord0);			
	lowp float alpha2 = alphaCol2.r;
	
	#ifdef SA_USE_CHANEL_ALPHA		
	if(texture2_alphachannel > 2)
		alpha2 = alphaCol2.a;
	#endif
	
	lowp vec4 color2 = vec4(texture2D(texture2, vCoord0).rgb, alpha2);
#else
	lowp vec4 color2 = texture2D(texture2, vCoord0);
#endif
    gl_FragColor = color1 * color2 * vColor0;
}