
#define TEXTURE_2D 0
#define TEXTURE_3D 1
#define TEXTURE_CUBE_MAP 2
#define TEXTURE_RECT 3
#ifndef TEXTURE_TYPE
#    define TEXTURE_TYPE TEXTURE_2D
#endif
#if GL_ES && TEXTURE_TYPE == TEXTURE_3D && !defined(GL_OES_texture_3D)
#    undef TEXTURE_TYPE
#    define TEXTURE_TYPE TEXTURE_2D
#elif GL_ES && TEXTURE_TYPE == TEXTURE_3D
#    extension GL_OES_texture_3D : enable
#elif GL_ES && TEXTURE_TYPE == TEXTURE_RECT
#    error texture rectangle not supported with GLES2
#elif TEXTURE_TYPE == TEXTURE_RECT
#    extension GL_ARB_texture_rectangle : enable
#endif
#define texture texture_glitchprops_semtexture_tcTexCoord0
#if TEXTURE_TYPE == TEXTURE_3D
uniform lowp sampler3D texture;
#elif TEXTURE_TYPE == TEXTURE_CUBE_MAP
uniform lowp samplerCube texture;
#elif TEXTURE_TYPE == TEXTURE_RECT
uniform lowp sampler2DRect texture;
#else
uniform lowp sampler2D texture;
#endif
#if TEXTURE_TYPE == TEXTURE_3D && defined(SPLIT_ALPHA)
uniform lowp sampler3D texture_alpha;
#elif TEXTURE_TYPE == TEXTURE_CUBE_MAP && defined(SPLIT_ALPHA)
uniform lowp samplerCube texture_alpha;
#elif TEXTURE_TYPE == TEXTURE_RECT && defined(SPLIT_ALPHA)
uniform lowp sampler2DRect texture_alpha;
#elif defined(SPLIT_ALPHA)
uniform lowp sampler2D texture_alpha;
#endif
#if defined(SPLIT_ALPHA)
uniform lowp int texture_alphachannel;
#endif
#if TEXTURE_TYPE == TEXTURE_3D || TEXTURE_TYPE == TEXTURE_CUBE_MAP
varying mediump vec3 vCoord0;
#else
varying mediump vec2 vCoord0;
#endif
varying	lowp vec4 vColor0;
void main()
{
	gl_FragColor =
#if TEXTURE_TYPE == TEXTURE_3D && defined(SPLIT_ALPHA)
		vec4(texture3D(texture, vCoord0).rgb * vColor0.rgb,			 
			 texture3D(texture_alpha, vCoord0).r * vColor0.a); 
#elif TEXTURE_TYPE == TEXTURE_3D
		texture3D(texture, vCoord0) * vColor0;
#elif TEXTURE_TYPE == TEXTURE_CUBE_MAP && defined(SPLIT_ALPHA)
		vec4(textureCube(texture, vCoord0).rgb * vColor0.rgb,
			 textureCube(texture_alpha, vCoord0).r * vColor0.a); 
#elif TEXTURE_TYPE == TEXTURE_CUBE_MAP
		textureCube(texture, vCoord0) * vColor0;
#elif TEXTURE_TYPE == TEXTURE_RECT && defined(SPLIT_ALPHA)
		vec4(textureRect(texture, vCoord0).rgb * vColor0.rgb,
			 textureRect(texture_alpha, vCoord0).r * vColor0.a); 
#elif TEXTURE_TYPE == TEXTURE_RECT
		texture2DRect(texture, vCoord0) * vColor0;
#elif defined(SPLIT_ALPHA)
		vec4(texture2D(texture, vCoord0).rgb * vColor0.rgb,
			 texture2D(texture_alpha, vCoord0).r * vColor0.a); 
#else
		texture2D(texture, vCoord0) * vColor0;
#endif
}