
uniform	lowp	sampler2D	texture0;
varying	mediump vec2 		vCoord0;
uniform lowp 	float	 	DesaturationFactor;
uniform lowp 	vec3	 	Shadows;
uniform lowp 	vec3		HighlightsMinusShadows;
uniform lowp 	vec3	 	Midtones;
uniform lowp 	float	 	ColorGradingBlendFactor;
#ifdef USE_COLORCORECTION	
	uniform lowp mat4 ColorMatrix;
#endif
void main()
{
	lowp vec4 color = texture2D(texture0, vCoord0);
	
	lowp vec3 desat			= vec3(0.33);
    lowp vec3 desatColor	= mix(color.rgb, vec3(dot(color.rgb, desat)), DesaturationFactor);
    lowp vec3 gradedColor	= Shadows + desatColor * HighlightsMinusShadows + (1.0 - 2.0 * abs(desatColor - vec3(0.5))) * Midtones;
    lowp vec4 final 		= vec4(mix(color.rgb, gradedColor, ColorGradingBlendFactor), 1.0);
#ifdef USE_COLORCORECTION
	final = ColorMatrix * color;
#endif
    gl_FragColor = final;
}