

#ifndef TEX0
	#define TEX0 DiffuseTexture
#endif
#ifdef SPLIT_ALPHA
	#ifndef TEX0_a
		#define TEX0_a DiffuseTexture_alpha
	#endif
	#ifndef TEX0_ac
		#define TEX0_ac DiffuseTexture_alphachannel
	#endif	
#endif
uniform		lowp	sampler2D	TEX0;
#ifdef SPLIT_ALPHA
	uniform lowp    sampler2D TEX0_a;
	uniform lowp    int       TEX0_ac;
#endif
#ifndef _TEXCOORD0
	#define _TEXCOORD0 texCoord0
#else
	#define DEFAULT_COORD_0
#endif
#ifndef NO_VAR
	varying		mediump	vec2 	_TEXCOORD0;
	lowp vec4	getTex0()
	{
		#ifdef SPLIT_ALPHA
			
			lowp vec4 alphaCol = texture2D(TEX0_a, _TEXCOORD0, -1.0);			
			lowp float alpha = alphaCol.r;
			
			if(TEX0_ac > 2)
				alpha = alphaCol.a;
			
			return vec4(texture2D(TEX0, _TEXCOORD0, -1.0).rgb, alpha); 
			
		#else
			return texture2D(TEX0, _TEXCOORD0, -1.0);
		#endif
	}
#else
	#ifdef DEFAULT_COORD_0
		lowp vec4	getTex0()
		{
			#ifdef SPLIT_ALPHA
				
				lowp vec4 alphaCol = texture2D(TEX0_a, _TEXCOORD0, -1.0);			
				lowp float alpha = alphaCol.r;
			
				#ifdef SA_USE_CHANEL_ALPHA
				if(TEX0_ac > 2)
					alpha = alphaCol.a;
				#endif	
				
				return vec4(texture2D(TEX0, _TEXCOORD0, -1.0).rgb, alpha); 
				
			#else
				return texture2D(TEX0, _TEXCOORD0, -1.0);
			#endif
		}
	#else
		lowp vec4	getTex0(mediump vec2 coord)
		{	
			#ifdef SPLIT_ALPHA				
				
				lowp vec4 alphaCol = texture2D(TEX0_a, coord, -1.0);			
				lowp float alpha = alphaCol.r;
			
				#ifdef SA_USE_CHANEL_ALPHA
				if(TEX0_ac > 2)
					alpha = alphaCol.a;
				#endif
					
				return vec4(texture2D(TEX0, coord, -1.0).rgb, alpha); 
				
			#else
				return texture2D(TEX0, coord, -1.0);
			#endif
		}
	#endif
#endif


#ifndef TEX1
   #define TEX1 DiffuseTexture1
#endif
#ifdef SPLIT_ALPHA
   #ifndef TEX1_a
      #define TEX1_a DiffuseTexture1_alpha
   #endif
   #ifndef TEX1_ac
      #define TEX1_ac DiffuseTexture1_alphachannel
   #endif   
#endif
uniform      lowp   sampler2D   TEX1;
#ifdef SPLIT_ALPHA
   uniform lowp    sampler2D TEX1_a;
   uniform lowp    int       TEX1_ac;
#endif
#ifndef _TEXCOORD1
   #define _TEXCOORD1 texCoord1
#else
   #define DEFAULT_COORD_1
#endif
#ifndef NO_VAR
   varying      mediump   vec2    _TEXCOORD1;
   lowp vec4   getTex1()
   {
      #ifdef SPLIT_ALPHA
      	
	lowp vec4 alphaCol = texture2D(TEX1_a, _TEXCOORD1, -1.0);			
	lowp float alpha = alphaCol.r;
	
	#ifdef SA_USE_CHANEL_ALPHA      
	if(TEX1_ac > 2)
		alpha = alphaCol.a;
	#endif	
	
        return vec4(texture2D(TEX1, _TEXCOORD1, -1.0).rgb, alpha);
	
      #else
         return texture2D(TEX1, _TEXCOORD1, -1.0);
      #endif      
   }
#else
   #ifdef DEFAULT_COORD_1
      lowp vec4   getTex1()
      {
      #ifdef SPLIT_ALPHA
	
	lowp vec4 alphaCol = texture2D(TEX1_a, _TEXCOORD1, -1.0);			
	lowp float alpha = alphaCol.r;
	
	#ifdef SA_USE_CHANEL_ALPHA	
	if(TEX1_ac > 2)
		alpha = alphaCol.a;
        #endif
	
	return vec4(texture2D(TEX1, _TEXCOORD1, -1.0).rgb, alpha);
	
         #else
            return texture2D(TEX1, _TEXCOORD1, -1.0);
         #endif
      }
   #else
      lowp vec4   getTex1(mediump vec2 coord)
      {
         #ifdef SPLIT_ALPHA
	
	lowp vec4 alphaCol = texture2D(TEX1_a, coord, -1.0);			
	lowp float alpha = alphaCol.r;
	
	#ifdef SA_USE_CHANEL_ALPHA	
	if(TEX1_ac > 2)
		alpha = alphaCol.a;
        #endif
	
	return vec4(texture2D(TEX1, coord, -1.0).rgb, alpha);
	
			     
         #else
            return texture2D(TEX1, coord, -1.0);
         #endif
      }
   #endif
#endif



#ifndef COLORBASE_F
#define COLORBASE_F
#define setPixel setColor
void setColor(lowp vec4 c)
{
	gl_FragColor = c;	
}
#endif

varying		lowp	vec4 	vertColor;
lowp vec4	getColor()
{
	return vertColor;
}

void main()
{
	highp vec4 tex0Data = getTex0();
	highp vec4 tex1Data = getTex1();
	highp vec4 colorData = getColor() * 0.00001 + 1.0;
	setColor(tex0Data * tex1Data * colorData);
}	